-- =============================================================================
-- Project Euler
-- Problem 45
--
-- Author: Rui Carlos A. Gonalves <rcgoncalves.pt@gmail.com>
-- Date: 02/2007
-- =============================================================================
module Prob045 where

t n=div (n*(n+1)) 2

triangle 0=False
triangle n=let c=(fromIntegral (-n))::Double
               delta=1/2^2-2*c
               r1=(-1/2)+sqrt(delta)
               r2=(-1/2)-sqrt(delta)
           in (((r1>0) && (t (round r1)==n)) || ((r2>0) && (t (round r2)==n)))

p n=div (n*(3*n-1)) 2

pentagonal 0=False
pentagonal n=let c=(fromIntegral (-n))::Double
                 delta=1/2^2-6*c
                 r1=1/6+sqrt(delta)/3
                 r2=1/6-sqrt(delta)/3
             in (((r1>0) && (p (round r1)==n)) || ((r2>0) && (p (round r2)==n)))

h n=n*(2*n-1)
hs=map h [1..]

hexagonal 0=False
hexagonal n=let c=(fromIntegral (-n))::Double
                delta=1-8*c
                r1=1/4+sqrt(delta)/4
                r2=1/4-sqrt(delta)/4
             in (((r1>0) && (h (round r1)==n)) || ((r2>0) && (h (round r2)==n)))

res=head.(dropWhile (<=40755)).(filter (\n->pentagonal n && triangle n))$hs

main=do putStr "Problem 45 - Answer: "
        print res
        return 0
