-- =============================================================================
-- Project Euler
-- Problem 75
--
-- Author: Rui Carlos A. Gonçalves <rcgoncalves.pt@gmail.com>
-- Date: 02/2007
-- =============================================================================
module Prob075 where

import Data.Array
 
triangs :: [Int]
triangs = [p | n <- [2..1000],
               m <- [1..n-1],
               gcd m n == 1,
               odd (m+n),
               let p = 2 * (n^2 + m*n),
               p <= 2*10^6]
 
problem_75 :: Int
problem_75 = length
       $ filter (\(_, c) -> c == 1)
       $ assocs
       $ (\ns -> accumArray (+) 0 (1, 2*10^6) [(n, 1) | n <- ns, inRange (1, 2*10^6) n])
       $ concatMap (\n -> takeWhile (<=2*10^6) [n,2*n..]) triangs
