/**
 * Project Euler
 * Problem 14
 *
 * @author Rui Carlos A. Gonalves <rcgoncalves.pt@gmail.com>
 * @date 02/2007
 */
#include <stdio.h>

#define DIM 1000000

int seqlen(unsigned long long int n,unsigned long long int vals[DIM])
{
  if(n<DIM)
  {
    if(!vals[n])
    {
      if(n%2) vals[n]=1+seqlen(3*n+1,vals);
      else vals[n]=1+seqlen(n/2,vals);
    }

    return vals[n];
  }
  else
  {
    if(n%2) return 1+seqlen(3*n+1,vals);
    else return 1+seqlen(n/2,vals);
  }
}

int main()
{
  unsigned long long int vals[DIM];
  unsigned long long int n,pos;
  int tmp,max;

  vals[0]=1;
  vals[1]=1;
  for(n=2;n<DIM;n++)
    vals[n]=0;

  for(n=1,max=1,pos=1;n<1000000;n++)
  {
    tmp=seqlen(n,vals);
    if(tmp>max)
    {
      max=tmp;
      pos=n;
    }
  }

  printf("Problem 14 - Answer: %lld (%d)\n",pos,max);

  return 0;
}
