/**
 * Project Euler
 * Problem 27
 *
 * @author Rui Carlos A. Gonçalves <rcgoncalves.pt@gmail.com>
 * @date 12/2008
 */
#include <stdio.h>
#include <stdlib.h>

#define MAX 1000
#define DIM 100000

int eratosthenes(char vals[DIM])
{
  int i,j;

  for(i=0;i<DIM;i++)
    vals[i]=1;

  vals[0]=0;
  vals[1]=0;
  for(i=2;i<DIM;i++)
    if(vals[i])
      for(j=2*i;j<DIM;j+=i)
        vals[j]=0;

  return 0;
}

int eval(int a,int b,int x)
{
  int tmp=x*x+a*x+b;
  return tmp>0?tmp:0;
}

int countPrimes(int a,int b,char primes[DIM])
{
  int i;

  for(i=0;primes[eval(a,b,i)];i++);

  return i-1;
}

int main()
{
  int max,amax,bmax;
  int count,a,b;
  char primes[DIM];
  eratosthenes(primes);

  max=0;
  amax=0;
  bmax=0;
  for(a=-MAX+1;a<MAX;a++)
    for(b=-MAX+1;b<MAX;b++)
    {
      count=countPrimes(a,b,primes);
      if(count>max)
      {
        max=count;
        amax=a;
        bmax=b;
      }
    }

  printf("Problem 27 - Answer: %d",amax*bmax);

  return 0;
}
