/**
 * Project Euler
 * Problem 46
 *
 * @author Rui Carlos A. Gonçalves <rcgoncalves.pt@gmail.com>
 * @date 12/2008
 */
#include <stdio.h>
#include <stdlib.h>

#define DIM 50000000

int eratosthenes(char vals[DIM])
{
  int i,j;

  for(i=0;i<DIM;i++)
    vals[i]=1;

  vals[0]=0;
  vals[1]=0;
  for(i=2;i<DIM;i++)
    if(vals[i])
      for(j=2*i;j<DIM;j+=i)
        vals[j]=0;

  return 0;
}

int primesToList(char primes[DIM],int res[DIM])
{
  int i;
  int j;

  for(i=0,j=0;i<DIM;i++)
    if(primes[i])
    {
      res[j]=i;
      j++;
    }

  return j;
}

int test(int n,int primesList[])
{
  int i;
  int j;
  int x;
  int res=1;

  for(i=0;primesList[i]<n&&res;i++)
    for(j=0,x=primesList[i];x<=n&&res;j++,x=primesList[i]+2*j*j)
      if(n==x) res=0;

  return !res;
}

int main()
{
  int n;
  int stop;
  char* primes=(char*)malloc(DIM*sizeof(char));
  int* primesList=(int*)malloc(DIM/10*sizeof(int));
  eratosthenes(primes);
  primesToList(primes,primesList);

  for(n=9,stop=0;!stop;n++)
  {
    if(!primes[n]&&n%2==1)
    {
      stop=!test(n,primesList);
    }
  }

  printf("Problem 46 - Answer: %d\n",n-1);

  return 0;
}
