/**
 * Project Euler
 * Problem 58
 *
 * @author Rui Carlos A. Gonalves <rcgoncalves.pt@gmail.com>
 * @date 02/2007
 */
#include <stdio.h>
#include <stdlib.h>

#define DIM 700000000

int eratosthenes(char vals[DIM])
{
  int i,j;

  for(i=0;i<DIM;i++)
    vals[i]=1;

  vals[0]=0;
  vals[1]=0;
  for(i=2;i<DIM;i++)
    if(vals[i])
      for(j=2*i;j<DIM;j+=i)
        vals[j]=0;

  return 0;
}

int level(char primes[DIM])
{
  int first,level,stop,count;
  int d1,d2,d3,d4;

  for(first=2,level=1,count=0,stop=1;stop;first+=8*level,level++)
  {
    d1=first+2*level-1;
    d2=first+4*level-1;
    d3=first+6*level-1;
    d4=first+8*level-1;

    if(d4>DIM) exit(2);

    count+=primes[d1]+primes[d2]+primes[d3]+primes[d4];
    stop=(count/(float)(4*level+1))>.1;
  }

  return (2*level-1);
}

int main()
{
  char* primes=calloc(DIM,sizeof(char));
  if(!primes) exit(1);
  eratosthenes(primes);

  printf("Problem 58 - Answer: %d\n",level(primes));

  return 0;
}
