/**
 * Project Euler
 * Problem 69
 *
 * @author Rui Carlos A. Gonalves <rcgoncalves.pt@gmail.com>
 * @date 03/2011
 */
#include <stdio.h>
#include <limits.h>
#include <stdint.h>

#define DIM 100

int eratosthenes(char vals[DIM])
{
  int i,j;

  for(i=0;i<DIM;i++)
    vals[i]=1;

  vals[0]=0;
  vals[1]=0;
  for(i=2;i<DIM;i++)
    if(vals[i])
      for(j=2*i;j<DIM;j+=i)
        vals[j]=0;

  return 0;
}

int main()
{
  int i,res;
  char primes[DIM];

  eratosthenes(primes);

  res=1;
  i=2;
  while(res*i<=1000000)
  {
    if(primes[i]) res*=i;
    i++;
  }

  printf("Problem 69 - Answer: %d\n",res);

  return 0;
}
