/**
 * Project Euler
 * Problem 74
 *
 * @author Rui Carlos A. Gonçalves <rcgoncalves.pt@gmail.com>
 * @date 03/2011
 */
#include <stdio.h>

#define MAX 64

int facts[]={1,1,2,6,24,120,720,5040,40320,362880};

int repeated(int n,int prev[MAX])
{
  int i;
  for(i=0;i<n;i++)
  {
    if(prev[n]==prev[i]) return 1;
  }

  return 0;
}

int dfact(int n)
{
  int res=0;
  while(n>0)
  {
    res+=facts[n%10];
    n=n/10;
  }
  return res;
}

int chain(int n)
{
  int prev[MAX];
  int length=0,i;

  for(i=0;i<MAX;i++) prev[i]=0;

  prev[0]=n;

  do
  {
    length++;
    prev[length]=dfact(prev[length-1]);
  } while(!repeated(length,prev));

  return length;
}

int main()
{
  int n=1000000;
  int res=0,i;

  for(i=1;i<=n;i++)
  {
    if(chain(i)==60) res++;
  }
  printf("Problem 74 - Answer: %d\n",res);

  return 0;
}
