/**
 * Project Euler
 * Problem 87
 *
 * @author Rui Carlos A. Gonalves <rcgoncalves.pt@gmail.com>
 * @date 03/2011
 */
#include <stdio.h>
#include <stdlib.h>

#define DIM 8000
#define SQ(X) ((X)*(X))
#define CU(X) ((X)*(X)*(X))
#define FTH(X) ((X)*(X)*(X)*(X))

int eratosthenes(char vals[DIM])
{
  int i,j;

  for(i=0;i<DIM;i++)
    vals[i]=1;

  vals[0]=0;
  vals[1]=0;
  for(i=2;i<DIM;i++)
    if(vals[i])
      for(j=2*i;j<DIM;j+=i)
        vals[j]=0;

  return 0;
}

int plist(char primes[DIM],int list[DIM])
{
  int i,j;
  for(i=0,j=0;i<DIM;i++)
  {
    if(primes[i]) list[j++]=i;
  }
  return j;
}

int main()
{
  long x1,x2,x3,max=50e6;
  int i,j,k,count;
  char primes[DIM];
  int list[DIM];
  char* values=(char*)calloc(max,sizeof(char));

  eratosthenes(primes);
  plist(primes,list);

  i=0;
  x1=SQ(list[0]);
  while(x1<max)
  {
    j=0;
    x2=CU(list[0]);
    while(x1+x2<max)
    {
      k=0;
      x3=FTH(list[0]);
      while(x1+x2+x3<max)
      {
	values[x1+x2+x3]=1;
	k++;
	x3=FTH(list[k]);
      }
      j++;
      x2=CU(list[j]);
    }
    i++;
    x1=SQ(list[i]);
  }

  for(i=0,count=0;i<max;i++) if(values[i]) count++;

  printf("Problem 87 - Answer: %d\n",count);

  return 0;
}
